package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectRangePageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectRangeRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectRangeSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.util.object.BeanUtils;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectRangeDO;
import com.zt.plat.module.qms.business.config.dal.mapper.ConfigAssayMethodProjectRangeMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.diffList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.*;

/**
 * 检测方法分析项目区间 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigAssayMethodProjectRangeServiceImpl implements ConfigAssayMethodProjectRangeService {

    @Resource
    private ConfigAssayMethodProjectRangeMapper configAssayMethodProjectRangeMapper;

    @Override
    public ConfigAssayMethodProjectRangeRespVO createConfigAssayMethodProjectRange(ConfigAssayMethodProjectRangeSaveReqVO createReqVO) {
        // 插入
        ConfigAssayMethodProjectRangeDO configAssayMethodProjectRange = BeanUtils.toBean(createReqVO, ConfigAssayMethodProjectRangeDO.class);
        configAssayMethodProjectRangeMapper.insert(configAssayMethodProjectRange);
        // 返回
        return BeanUtils.toBean(configAssayMethodProjectRange, ConfigAssayMethodProjectRangeRespVO.class);
    }

    @Override
    public void updateConfigAssayMethodProjectRange(ConfigAssayMethodProjectRangeSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigAssayMethodProjectRangeExists(updateReqVO.getId());
        // 更新
        ConfigAssayMethodProjectRangeDO updateObj = BeanUtils.toBean(updateReqVO, ConfigAssayMethodProjectRangeDO.class);
        configAssayMethodProjectRangeMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigAssayMethodProjectRange(Long id) {
        // 校验存在
        validateConfigAssayMethodProjectRangeExists(id);
        // 删除
        configAssayMethodProjectRangeMapper.deleteById(id);
    }

    @Override
        public void deleteConfigAssayMethodProjectRangeListByIds(List<Long> ids) {
        // 校验存在
        validateConfigAssayMethodProjectRangeExists(ids);
        // 删除
        configAssayMethodProjectRangeMapper.deleteByIds(ids);
        }

    private void validateConfigAssayMethodProjectRangeExists(List<Long> ids) {
        List<ConfigAssayMethodProjectRangeDO> list = configAssayMethodProjectRangeMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_ASSAY_METHOD_PROJECT_RANGE_NOT_EXISTS);
        }
    }

    private void validateConfigAssayMethodProjectRangeExists(Long id) {
        if (configAssayMethodProjectRangeMapper.selectById(id) == null) {
            throw exception(CONFIG_ASSAY_METHOD_PROJECT_RANGE_NOT_EXISTS);
        }
    }

    @Override
    public ConfigAssayMethodProjectRangeDO getConfigAssayMethodProjectRange(Long id) {
        return configAssayMethodProjectRangeMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigAssayMethodProjectRangeDO> getConfigAssayMethodProjectRangePage(ConfigAssayMethodProjectRangePageReqVO pageReqVO) {
        return configAssayMethodProjectRangeMapper.selectPage(pageReqVO);
    }

}